#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "zap0001four4xi.py">
#<abstract4xi abstract = "zaps to direction four"/>
#<verify4xi verification = "11" target = "zap2actor4xi.py"/>
#<refer4xi reference = "zap2actor4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'zap0001four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
ack2dragontrace = False
#"
#/>      

# -------------------------------------------------------------------------------------------------
#<function4xi function = "zap0001four4xi" usage = "target function for zap0000four4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def zap0001four4xi(queue2four, consumer_channel2four, publisher_channel2four, kb2four):   
    '''
    returns skeleton to direction four via queue
    '''

    

    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                      
    # -------------------------------------------------------------------------------------------------                                                               
      
    time2start = time4xi()  
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF ZAP0001FOUR4XI - STARTED TIME: ", time2start)                                       # 
        print("\n (STEP 1A2/33) OF ZAP0001FOUR4XI -  QUEUE2FOUR: ", queue2four)                                        # 
        print("\n (STEP 1A3/33) OF ZAP0001FOUR4XI -  CONSUME_CHANNEL4FOUR: ", consumer_channel2four)                   # 
        print("\n (STEP 1A4/33) OF ZAP0001FOUR4XI -  PUBLISHER_CHANNEL4FOUR: ", publisher_channel2four)                #     
        # print("\n (STEP 1A5/33) OF ZAP0001FOUR4XI -  KB2FOUR: ", kb2four)                                              # 


        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    if ack2debug is True:
        print("\n (STEP 2A/33) OF ZAP0001FOUR4XI - TRYING TO PUT TO QUEUE2FOUR: ", queue2four)                         # 
    
    ack2put = False                                                                                                                           
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SKELETON NODE FOR DIRECTION FOUR TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        key2kb = '1x-1y1z'
        kb2put = {}
        kb2put[key2kb] = kb2four[key2kb]
        queue2four.put(kb2put)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF ZAP0001FOUR4XI - SUCCEEDED TO PUT TO QUEUE: ", queue2four, " KB2PUT: ", kb2put) # {'1x-1y1z': {'2xi': {1: 4, 2: 2, 3: {1: 6.283185307179586, 2: '#AFAAA5', 3: 1, 4: 6.283185307179586}, 4: 'dragon1x-1y1z', 5: '#AB712F', 6: 4, 7: 33, 8: 1.7325080757, 9: 0.267949192431, 10: 8, 11: '{started; sense-of-4Skeleton4Xi-started: 11:25:22 12/07/10 Pacific Standard Time}', 12: 'sense', 13: 2}, '8xi': {}, '4xi': {}}}
 
            
        ack2put = True    
    except:
        print("\n (STEP 2D/33) OF ZAP0001FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF ZAP0001FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL4FOUR: ", publisher_channel2four)
                                                                                                                    # 
    if ack2put is True:
        message2send4four = "<ack2put4xi>layer02four</ack2put4xi>"
    else:
        message2send4four = "<nack2put4xi>layer02four</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel2four.send(message2send4four)
        if ack2debug is True:     
            print(" (STEP 3B/33) OF ZAP0001FOUR4XI -  SENT MESSAGE2SEND4FOUR: ", message2send4four, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
                                                                                                                    # <ack2put4xi>layer02four</ack2put4xi>  TO PUBLISHER_CHANNEL2FOUR:  <read-write PipeConnection, handle 272>
    except:
        print(" (STEP 3C/33) OF ZAP0001FOUR4XI *** FAILED TO SEND MESSAGE2SEND4FOUR: ", message2send4four, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF ZAP0001FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
                                                                                                                    # 
          
    return queue2four    
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_zap2actor4xi.txt
#   scope-sense*4xi.xml
#   sense-test-zap2actor4xi.xml
#   reason-test-zap2actor4xi.xml
#   ace-test-zap2actor4xi4xi.xml"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zap0001four4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>
